/*! 
////////////////////////////////////////////////////////////////////

 *	\class		CHtmlEdit 

 *  \brief  <b>	The output is a simple HTML page with a Table. Useful
				for publishing the contents of a Listcontrol </b>
				
 *  \author	<b>	Thomas Latuske </b>

 *  \date		08.04.2004

////////////////////////////////////////////////////////////////////
*/

#if !defined(AFX_HTMLEDIT_H__2AB3802D_1646_4AC1_AE7C_D440B0D4569E__INCLUDED_)
#define AFX_HTMLEDIT_H__2AB3802D_1646_4AC1_AE7C_D440B0D4569E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*
************************************************************************************************************
Usage:
1.		CHtmlEdit oHE("Coole Tabelle!", "thomlatu", "A lovely Table", "Scrolling text to stop and continue" );
				  ^^^Prefer local usage! That means within a routine
2.		oHE.InsertTableHeader(3, "Header 1","Header 2","Header 3");
3.		oHE.InsertTableRow("Row 1","<Row@1>","Row 1");
		oHE.InsertTableRow("Row 2","Row 2","<Row@2>");
		oHE.InsertTableRow("<Row@3>","Row 3","Row 3");
4.		oHE.WriteHTMLFile("TABLE.HTML");
*************************************************************************************************************
*/


class CHtmlEdit  
{
public:
	void WriteHTMLFile(CString sFullPath);
	// Add a variable No of columns as header to the Table:
	int InsertTableHeader(int iItemNo, /// No. of columns
						  CString sFirstItem, // The CString which is to add to the first column
						  ...); // all other CStrings(!) 
	// Add a variable No of columns as to the Table:
	int InsertTableRow(CString sFirstItem, // The CString which is to add to the first column
					   ...); // all other CStrings(!) 

	// C'tor which initializes the Variables:
	CHtmlEdit(CString sTitle = "Default",			// Title of the HTML-File
			  CString sAuthor = "N/A",				// Author of the HTML-File
			  CString sTableCaption = "Standard",	// The caption of the Table
			  CString sMarqueeText = "",			// The Scrolling Text
			  CString sLink = "",					// A Link which will be placed in the Footer
			  CString sLinkText= "",				// Text for the link above
			  CString sBkColor = "#C0C0C0",			// Backgroundcolor of the HTML-File (HTML-Notation)
			  CString sTextColor = "#000000",		// Textcolor of the HTML-File (HTML-Notation)
			  CString sHeaderBkColor = "#ff6666",	// Backgroundcolor of the Header (HTML-Notation)
			  CString sTableBkColor = "#ffffcc");	// Backgroundcolor of the Table (HTML-Notation)
	// De-c'tor:
	virtual ~CHtmlEdit();

private:
	CString m_HTML_MarqueeText;
	void InitTABLEFOOT();
	void InitTABLEBODY();
	void InitHTMLHEAD();
	void InitMARQUEE();
	// if a string begins with '<' and ends with '>' it is assumed that it is an em@il address:
	BOOL isEmail(CString &sString);
	void GetTableHeadLine();
	void GetTableBodyLine();
	void CreateFileHeader();
	
	CString m_HTML_sTemplateContainer;	// Variable which holds the contents of the Template
	CString m_HTML_sTitle;			// see C'tor
	CString m_HTML_sAuthor;			// see C'tor
	CString m_HTML_sBkColor;		// see C'tor
	CString m_HTML_sTextColor;		// see C'tor
	CString m_HTML_sTableCaption;	// see C'tor
	CString m_HTML_sHeaderBkColor;	// see C'tor
	CString m_HTML_sTableBkColor;	// see C'tor
	CString m_HTML_sLink;			// see C'tor
	CString m_HTML_sLinkText;		// see C'tor
	CString m_HTML_sMarquee;		// see C'tor

	CString m_HTML_sTableHead;
	CString m_Tmp_sTableHeadLine;
	CString m_HTML_sTableBody;
	CString m_Tmp_sTableBodyLine;
	CString m_HTML_sTableFoot;

	int m_HTML_iColumns;
	
	// Load the Template HTML-File into the Container:

	// get the length of a file:
};

#endif // !defined(AFX_HTMLEDIT_H__2AB3802D_1646_4AC1_AE7C_D440B0D4569E__INCLUDED_)
